/* Copyright 2003-2006  Alexander V. Diemand

    This file is part of MolTalk.

    MolTalk is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MolTalk is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MolTalk; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */
 
/* vim: set filetype=objc: */


#ifndef MTPRIVATESTRUCTURE_H
#define MTPRIVATESTRUCTURE_H


#include <Foundation/Foundation.h>

#include "MTStructure.h"


@class MTStream;
@class MTResidue;
@class MTChain;


@interface MTStructure (Private)

/*
 *   writes out the complete structure to a file in PDB format
 */
-(void)writePDBHeaderTo:(MTStream*)s;	//@nodoc
-(void)writePDBRemark:(int)remid to:(MTStream*)s;	//@nodoc
-(void)writePDBChain:(MTChain*)c to:(MTStream*)s fromSerial:(unsigned int*)ser;	//@nodoc
-(void)writePDBResidue:(MTResidue*)r inChain:(MTChain*)c to:(MTStream*)s fromSerial:(unsigned int*)ser;	//@nodoc
-(void)writePDBHeterogen:(MTResidue*)r inChain:(MTChain*)c to:(MTStream*)s fromSerial:(unsigned int*)ser;	//@nodoc
-(void)writePDBConectTo:(MTStream*)s;	//@nodoc
-(void)writePDBConectResidue:(MTResidue*)r to:(MTStream*)s;	//@nodoc

/*
 *   adds a new chain with the identifier c_chain
 */
-(MTChain*)mkChain:(NSNumber*)c_chain;	//@nodoc

/*
 *   write access to fields
 */
-(void)expdata:(int)expdata;	//@nodoc
-(void)resolution:(float)resolution;	//@nodoc
-(void)header:(NSString*)header;	//@nodoc
-(void)title:(NSString*)title;	//@nodoc
-(void)keywords:(NSString*)kw;	//@nodoc
-(void)date:(NSCalendarDate*)date;	//@nodoc
-(void)pdbcode:(NSString*)pdbcode;	//@nodoc
-(void)revdate:(NSCalendarDate*)revdate;	//@nodoc
-(void)hetname:(id)name forKey:(NSString*)key;	//@nodoc

@end

#endif /* MTPRIVATESTRUCTURE_H */
 
